#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

extern Dev rootdevtab;
extern Dev consdevtab;
extern Dev dupdevtab;
extern Dev envdevtab;
extern Dev etherdevtab;
extern Dev flashdevtab;
extern Dev ipdevtab;
extern Dev kprofdevtab;
extern Dev mntdevtab;
extern Dev pipedevtab;
extern Dev procdevtab;
extern Dev capdevtab;
extern Dev srvdevtab;
extern Dev ssldevtab;
extern Dev uartdevtab;
extern Dev sddevtab;
Dev* devtab[]={
	&rootdevtab,
	&consdevtab,
	&dupdevtab,
	&envdevtab,
	&etherdevtab,
	&flashdevtab,
	&ipdevtab,
	&kprofdevtab,
	&mntdevtab,
	&pipedevtab,
	&procdevtab,
	&capdevtab,
	&srvdevtab,
	&ssldevtab,
	&uartdevtab,
	&sddevtab,
	nil,
};

extern void ethermediumlink(void);
void links(void){
	bootlinks();

	ethermediumlink();
}

#include "../port/sd.h"
extern SDifc sdataifc;
SDifc* sdifc[] = {
	&sdataifc,
	nil,
};

extern PhysUart sa1110physuart;
PhysUart* physuart[] = {
	&sa1110physuart,
	nil,
};

#include "../ip/ip.h"
extern void ilinit(Fs*);
extern void tcpinit(Fs*);
extern void udpinit(Fs*);
extern void ipifcinit(Fs*);
extern void icmpinit(Fs*);
extern void icmp6init(Fs*);
extern void greinit(Fs*);
extern void ipmuxinit(Fs*);
void (*ipprotoinit[])(Fs*) = {
	ilinit,
	tcpinit,
	udpinit,
	ipifcinit,
	icmpinit,
	icmp6init,
	greinit,
	ipmuxinit,
	nil,
};

	int cpuserver = 1;
char* conffile = "ts7200";
ulong kerndate = KERNDATE;
